diff -Nur irc2.10.3p7/ircd/s_conf.c irc2.10.3p7+hemp2+DK+B5/ircd/s_conf.c
--- irc2.10.3p7/ircd/s_conf.c	Sun May  9 21:32:40 2004
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_conf.c	Tue May 11 15:25:04 2004
@@ -178,8 +178,9 @@
 
 	for (aconf = conf; aconf; aconf = aconf->next)
 	    {
-		if ((aconf->status != CONF_CLIENT) &&
-		    (aconf->status != CONF_RCLIENT))
+		if (IsIllegal(aconf))
+			continue;
+		if (!(aconf->status & (CONF_CLIENT | CONF_RCLIENT)))
 			continue;
 		if (aconf->port && aconf->port != cptr->acpt->port)
 			continue;
@@ -230,6 +231,16 @@
 attach_iline:
 		if (aconf->status & CONF_RCLIENT)
 			SetRestricted(cptr);
+#ifdef ILINE_FLAGS
+		if (aconf->status & CONF_EXEMPT)
+		{
+			cptr->user->flags |= FLAGS_EXEMPT;
+		}
+		if (!hp && (aconf->status & CONF_RNODNS))
+		{
+			SetRestricted(cptr);
+		}
+#endif
 		get_sockhost(cptr, uhost);
 		if ((i = attach_conf(cptr, aconf)) < -1)
 			find_bounce(cptr, ConfClass(aconf), -1);
@@ -302,6 +313,7 @@
 						*aconf2 = aconf3->next;
 						aconf3->next = NULL;
 						free_conf(aconf);
+						
 					}
 					else
 					{
@@ -346,7 +358,7 @@
 aClient *cptr;
 {
 	Reg	Link	*lp;
-
+	
 	if (is_attached(aconf, cptr))
 		return 1;
 	if (IsIllegal(aconf))
@@ -359,9 +371,10 @@
 			return -3;    /* Use this for printing error message */
 	    }
 	if ((aconf->status & (CONF_CLIENT | CONF_RCLIENT)))
-	    {
+	{
 		int	hcnt = 0, ucnt = 0;
-
+		int ghcnt = 0, gucnt = 0;
+		Reg anUser *user = NULL;
 		/* check on local/global limits per host and per user@host */
 
 		/*
@@ -369,7 +382,64 @@
 		**	host check is done on the IP address.
 		**	user check is done on the IDENT reply.
 		*/
-		if (ConfMaxHLocal(aconf) > 0 || ConfMaxUHLocal(aconf) > 0) {
+		if (ConfMaxHLocal(aconf) > 0 || ConfMaxUHLocal(aconf) > 0 ||
+		    ConfMaxHGlobal(aconf) > 0 || ConfMaxUHGlobal(aconf) > 0 )
+		{
+			for ((user = hash_find_hostname(cptr->sockhost,NULL));user;user=user->hnext)
+			{
+				if (!mycmp(cptr->sockhost,user->host))
+				{
+					ghcnt++;
+					if (MyConnect(user->bcptr))
+					{
+						hcnt++;
+						if (!mycmp(user->bcptr->auth,cptr->auth))
+						{
+							ucnt++;
+							gucnt++;
+						}
+					}
+					else
+					{
+						if (!mycmp(user->username,cptr->user->username))
+						{
+							gucnt++;
+						}
+					}
+					if (ConfMaxUHLocal(aconf) > 0 &&
+					    ucnt >= ConfMaxUHLocal(aconf))
+					{
+						return -5;
+					}
+	
+					if (ConfMaxHLocal(aconf) > 0 &&
+					    hcnt >= ConfMaxHLocal(aconf))
+					{
+						return -4;
+					}
+					if (ConfMaxUHGlobal(aconf) > 0 &&
+					    gucnt >= ConfMaxUHGlobal(aconf))
+					{
+						return -7;
+					}
+					if (ConfMaxHGlobal(aconf) > 0 &&
+					     ghcnt >= ConfMaxHGlobal(aconf))
+					{
+						return -6;
+					}
+				}
+			}
+		}
+#ifndef NO_EXTENSIVE_LOCAL_LIMIT_CHECK
+		/* Part of old cpu intensive code which is checking user's 
+		 * ip against all all other local clients. Needed only when 
+		 * client changes it's hostname between connects.
+		 * Won't be needed on pure 2.11 net  -- jv
+		 */
+		
+		/* now, check local IP too */
+		if (ConfMaxHLocal(aconf) > 0 || ConfMaxUHLocal(aconf) > 0) 
+		{
 			Reg     aClient *acptr;
 			Reg     int     i;
 
@@ -391,38 +461,8 @@
 			    ucnt >= ConfMaxUHLocal(aconf))
 				return -5;      /* for error message */
 		}
-		/*
-		** Global limits
-		**	host check is done on the hostname (IP if unresolved)
-		**	user check is done on username
-		*/
-		if (ConfMaxHGlobal(aconf) > 0 || ConfMaxUHGlobal(aconf) > 0)
-		    {
-			Reg     aClient *acptr;
-			Reg     int     ghcnt = hcnt, gucnt = ucnt;
-
-			for (acptr = client; acptr; acptr = acptr->next)
-			    {
-				if (!IsPerson(acptr))
-					continue;
-				if (MyConnect(acptr) &&
-				    (ConfMaxHLocal(aconf) > 0 ||
-				     ConfMaxUHLocal(aconf) > 0))
-					continue;
-				if (!strcmp(cptr->sockhost, acptr->user->host))
-				    {
-					if (ConfMaxHGlobal(aconf) > 0 &&
-					    ++ghcnt >= ConfMaxHGlobal(aconf))
-						return -6;
-					if (ConfMaxUHGlobal(aconf) > 0 &&
-					    !strcmp(cptr->user->username,
-						    acptr->user->username) &&
-					    (++gucnt >=ConfMaxUHGlobal(aconf)))
-						return -7;
-				    }
-			    }
-		    }
-	    }
+#endif
+	}
 
 	lp = make_link();
 	istat.is_conflink++;
@@ -730,12 +770,20 @@
 		if (!BadPtr(bconf->host) && mycmp(bconf->host, aconf->host))
 			continue;
 
+#ifdef DELAY_ACCEPT
+                /* ignore ->passwd field */
+                if (!(aconf->status & CONF_LISTEN_PORT))
+                {
+#endif
 		if ((BadPtr(bconf->passwd) && !BadPtr(aconf->passwd)) ||
 		    (BadPtr(aconf->passwd) && !BadPtr(bconf->passwd)))
 			continue;
 		if (!BadPtr(bconf->passwd) &&
 		    mycmp(bconf->passwd, aconf->passwd))
 			continue;
+#ifdef DELAY_ACCEPT
+                }
+#endif
 
 		if ((BadPtr(bconf->name) && !BadPtr(aconf->name)) ||
 		    (BadPtr(aconf->name) && !BadPtr(bconf->name)))
@@ -787,18 +835,6 @@
 			 * this....-avalon
 			 */
 			acptr->hostp = NULL;
-#if defined(R_LINES) && ( defined(R_LINES_REHASH) && !defined(R_LINES_OFTEN) )
-			if (find_restrict(acptr))
-			    {
-				sendto_flag(SCH_NOTICE,
-					    "Restricting %s, closing lp",
-					    get_client_name(acptr,FALSE));
-				acptr->exitc = EXITC_RLINE;
-				if (exit_client(cptr,acptr,&me,"R-lined") ==
-				    FLUSH_BUFFER)
-					ret = FLUSH_BUFFER;
-			    }
-#endif
 		    }
 
 	while ((tmp2 = *tmp))
@@ -851,16 +887,18 @@
 		if (!(tmp2->status & CONF_ILLEGAL) || tmp2->clients)
 			tmp = &tmp2->next;
 		else
-		{
+		    {
 			*tmp = tmp2->next;
 			tmp2->next = NULL;
 			free_conf(tmp2);
-		}
-	
+		    }
 #ifdef CACHED_MOTD
 	read_motd(IRCDMOTD_PATH);
 #endif
-	rehashed = 1;
+	if (rehashed > 0)
+		rehashed = 2;	/* queue another rehash later */
+	else
+		rehashed = 1;
 	return ret;
 }
 
@@ -1134,12 +1172,6 @@
 			case 'q': /* network. USE WITH CAUTION! */
 				aconf->status = CONF_QUARANTINED_SERVER;
 				break;
-#ifdef R_LINES
-			case 'R': /* extended K line */
-			case 'r': /* Offers more options of how to restrict */
-				aconf->status = CONF_RESTRICT;
-				break;
-#endif
 			case 'S': /* Service. Same semantics as   */
 			case 's': /* CONF_OPERATOR                */
 				aconf->status = CONF_SERVICE;
@@ -1175,9 +1207,6 @@
 				|CONF_CLIENT|CONF_RCLIENT|CONF_KILL
 				|CONF_OTHERKILL|CONF_NOCONNECT_SERVER
 				|CONF_OPERATOR|CONF_LOCOP|CONF_LISTEN_PORT
-# ifdef R_LINES
-				|CONF_RESTRICT
-# endif
 				|CONF_SERVICE))
 				aconf->host = ipv6_convert(tmp);
 			else
@@ -1190,7 +1219,27 @@
 			DupString(aconf->passwd, tmp);
 			if ((tmp = getfield(NULL)) == NULL)
 				break;
-			DupString(aconf->name, tmp);
+#ifdef ILINE_FLAGS
+			if ((aconf->status & (CONF_CLIENT | CONF_RCLIENT)))
+			{
+				int shiftname = 0;
+				if (*tmp == '<' || (*tmp && *(tmp + 1) == '<'))
+				{
+					shiftname++;
+					aconf->status |= CONF_EXEMPT;
+				}
+				if (*tmp == '+' || (*tmp && *(tmp + 1) == '+'))
+				{
+					shiftname++;
+					aconf->status |= CONF_RNODNS;
+				}
+				DupString(aconf->name,tmp+shiftname);
+			}
+			else
+#endif
+			{
+				DupString(aconf->name, tmp);
+			}
 			if ((tmp = getfield(NULL)) == NULL)
 				break;
 			aconf->port = 0;
@@ -1249,26 +1298,109 @@
 			if (MaxLinks(Class(aconf)) < 0)
 				Class(aconf) = find_class(0);
 		    }
+#ifdef DELAY_ACCEPT
+                if (aconf->status & (CONF_LISTEN_PORT))
+                {
+                        if (aconf->passwd && strchr(aconf->passwd,'D'))
+                        {
+                                aconf->status |= CONF_DELAY;
+                        }
+                        if (aconf->passwd && strchr(aconf->passwd,'S'))
+                        {
+                                aconf->status |= CONF_SERVERONLY;
+                                /* feature, remove delay if serveronly */
+                                aconf->status &= ~CONF_DELAY;
+                        }
+                }
+#endif
+
 		if (aconf->status & (CONF_LISTEN_PORT|CONF_CLIENT|CONF_RCLIENT))
 		    {
-			aConfItem *bconf;
+			aConfItem *bconf = NULL;
 
 			if ((bconf = find_conf_entry(aconf, aconf->status)))
 			    {
 				delist_conf(bconf);
 				bconf->status &= ~CONF_ILLEGAL;
-				if (aconf->status == CONF_CLIENT)
+				if (aconf->status & (CONF_CLIENT | CONF_RCLIENT))
 				    {
+#ifdef ILINE_FLAGS
+					    if (aconf->status & CONF_EXEMPT)
+					    {
+						    bconf->status |= CONF_EXEMPT;
+					    }
+					    else
+					    {
+						    bconf->status &= ~CONF_EXEMPT;
+					    }
+					    if (aconf->status & CONF_RNODNS)
+					    {
+						    bconf->status |= CONF_RNODNS;
+					    }
+					    else
+					    {
+						    bconf->status &= ~CONF_RNODNS;
+					    }
+#endif
 					bconf->class->links -= bconf->clients;
 					bconf->class = aconf->class;
 					bconf->class->links += bconf->clients;
 				    }
+#ifdef DELAY_ACCEPT
+                                if (aconf->status & CONF_LISTEN_PORT)
+                                {
+                                        if (aconf->status & CONF_DELAY)
+                                        {
+                                                bconf->status &= ~CONF_SERVERONLY;
+                                                bconf->status |= CONF_DELAY;
+                                        }
+                                        else
+                                        {
+                                                bconf->status &= ~CONF_DELAY;
+                                        }
+                                        if (aconf->status & CONF_SERVERONLY)
+                                        {
+                                                bconf->status &= ~CONF_DELAY;
+                                                bconf->status |= CONF_SERVERONLY;
+                                        }
+                                        else
+                                        {
+                                                bconf->status &= ~CONF_SERVERONLY;
+                                        }
+                                }
+#endif
+
 				free_conf(aconf);
 				aconf = bconf;
 			    }
-			else if (aconf->host &&
-				 aconf->status == CONF_LISTEN_PORT)
-				(void)add_listener(aconf);
+			
+			if (aconf->host &&
+				 aconf->status & CONF_LISTEN_PORT)
+			{
+#ifdef DELAY_ACCEPT
+                                if (aconf->status & CONF_DELAY)
+                                {
+                                        /* we have Delayed ports and we
+                                         * are starting, don't bind them.
+                                         */
+                                        if (initialconf)
+                                                iconf.caccept = 1;
+                                }
+                                if (!((iconf.caccept < 2) &&
+                                    (aconf->status & CONF_DELAY)))
+                                {
+                                        aconf->status |= CONF_ACTIVE;
+                                }
+
+                                if (aconf->status & CONF_ACTIVE)
+#endif
+				{
+					if (!bconf)
+					{
+						add_listener(aconf);
+					}
+				}
+			}
 		    }
 		if (aconf->status & CONF_SERVICE)
 			aconf->port &= SERVICE_MASK_ALL;
@@ -1313,6 +1445,10 @@
 				MyFree(tmp2);
 				tmp2 = NULL;
 			    }
+			if (tmp3)
+			{
+				DupString(aconf->source_ip, tmp3);
+			}
 				
 		    }
 		/*
@@ -1435,9 +1571,8 @@
 	return -1;
 }
 
-int	find_kill(cptr, doall, comment)
+int	find_kill(cptr, comment)
 aClient	*cptr;
-int	doall;
 char	**comment;
 {
 	static char	reply[256];
@@ -1477,8 +1612,6 @@
 
 	for (tmp = kconf; tmp; tmp = tmp->next)
 	    {
-		if (!doall && (BadPtr(tmp->passwd) || !isdigit(*tmp->passwd)))
-			continue;
 		if (!(tmp->status & (CONF_KILL | CONF_OTHERKILL)))
 			continue; /* should never happen with kconf */
 		if (!tmp->host || !tmp->name)
@@ -1518,19 +1651,11 @@
 		if ((!check || match(tmp->name, check) == 0) &&
 		    (!tmp->port || (tmp->port == cptr->acpt->port)))   
 		    {
-			now = 0;
-			if (!BadPtr(tmp->passwd) && isdigit(*tmp->passwd) &&
-			    !(now = check_time_interval(tmp->passwd, reply)))
-				continue;
-			if (now == ERR_YOUWILLBEBANNED)
-				tmp = NULL;
 			break;
 		    }
 	    }
 
-	if (*reply)
-		sendto_one(cptr, reply, ME, now, cptr->name);
-	else if (tmp)
+	if (tmp)
 		sendto_one(cptr, ":%s %d %s :%s%s", ME,
 			   ERR_YOUREBANNEDCREEP, cptr->name,
 			   BadPtr(tmp->passwd) ?
@@ -1586,183 +1711,6 @@
 		    (strpbrk(key + l, tmp->passwd + l)))
 			break;
  	return (tmp ? -1 : 0);
-}
-
-#ifdef R_LINES
-/* find_restrict works against host/name and calls an outside program 
- * to determine whether a client is allowed to connect.  This allows 
- * more freedom to determine who is legal and who isn't, for example
- * machine load considerations.  The outside program is expected to 
- * return a reply line where the first word is either 'Y' or 'N' meaning 
- * "Yes Let them in" or "No don't let them in."  If the first word 
- * begins with neither 'Y' or 'N' the default is to let the person on.
- * It returns a value of 0 if the user is to be let through -Hoppie
- */
-int	find_restrict(cptr)
-aClient	*cptr;
-{
-	aConfItem *tmp;
-	char	reply[80], temprpl[80];
-	char	*rplhold = reply, *host, *name, *s;
-	char	rplchar = 'Y';
-	int	pi[2], rc = 0, n;
-
-	if (!cptr->user)
-		return 0;
-	name = cptr->user->username;
-	host = cptr->sockhost;
-	Debug((DEBUG_INFO, "R-line check for %s[%s]", name, host));
-
-	for (tmp = conf; tmp; tmp = tmp->next)
-	    {
-		if (tmp->status != CONF_RESTRICT ||
-		    (tmp->host && host && match(tmp->host, host)) ||
-		    (tmp->name && name && match(tmp->name, name)))
-			continue;
-
-		if (BadPtr(tmp->passwd))
-			continue;
-
-		if (pipe(pi) == -1)
-		    {
-			report_error("Error creating pipe for R-line %s:%s",
-				     &me);
-			return 0;
-		    }
-		switch (rc = vfork())
-		{
-		case -1 :
-			report_error("Error forking for R-line %s:%s", &me);
-			return 0;
-		case 0 :
-		    {
-			Reg	int	i;
-
-			(void)close(pi[0]);
-			for (i = 2; i < MAXCONNECTIONS; i++)
-				if (i != pi[1])
-					(void)close(i);
-			if (pi[1] != 2)
-				(void)dup2(pi[1], 2);
-			(void)dup2(2, 1);
-			if (pi[1] != 2 && pi[1] != 1)
-				(void)close(pi[1]);
-			(void)execlp(tmp->passwd, tmp->passwd, name, host,
-				     cptr->username, 0);
-			_exit(-1);
-		    }
-		default :
-			(void)close(pi[1]);
-			break;
-		}
-		*reply = '\0';
-		(void)dgets(-1, NULL, 0); /* make sure buffer marked empty */
-		while ((n = dgets(pi[0], temprpl, sizeof(temprpl)-1)) > 0)
-		    {
-			temprpl[n] = '\0';
-			if ((s = (char *)index(temprpl, '\n')))
-			      *s = '\0';
-			if (strlen(temprpl) + strlen(reply) < sizeof(reply)-2)
-				SPRINTF(rplhold,"%s %s", rplhold, temprpl);
-			else
-			    {
-				sendto_flag(SCH_ERROR,
-					    "R-line %s/%s: reply too long!",
-					    name, host);
-				break;
-			    }
-		    }
-		(void)dgets(-1, NULL, 0); /* make sure buffer marked empty */
-		(void)close(pi[0]);
-		(void)kill(rc, SIGKILL); /* cleanup time */
-#if !defined(USE_IAUTH)
-		(void)wait(0);
-#endif
-
-		rc = 0;
-		while (*rplhold == ' ')
-			rplhold++;
-		rplchar = *rplhold; /* Pull out the yes or no */
-		while (*rplhold != ' ')
-			rplhold++;
-		while (*rplhold == ' ')
-			rplhold++;
-		(void)strcpy(reply,rplhold);
-		rplhold = reply;
-
-		if ((rc = (rplchar == 'n' || rplchar == 'N')))
-			break;
-	    }
-	if (rc)
-	    {
-		sendto_one(cptr, ":%s %d %s :Restriction: %s",
-			   ME, ERR_YOUREBANNEDCREEP, cptr->name, reply);
-		return -1;
-	    }
-	return 0;
-}
-#endif
-
-
-/*
-** check against a set of time intervals
-*/
-
-static	int	check_time_interval(interval, reply)
-char	*interval, *reply;
-{
-	struct tm *tptr;
- 	char	*p;
- 	int	perm_min_hours, perm_min_minutes,
- 		perm_max_hours, perm_max_minutes;
- 	int	now, perm_min, perm_max;
-
-	tptr = localtime(&timeofday);
- 	now = tptr->tm_hour * 60 + tptr->tm_min;
-
-	while (interval)
-	    {
-		p = (char *)index(interval, ',');
-		if (p)
-			*p = '\0';
-		if (sscanf(interval, "%2d%2d-%2d%2d",
-			   &perm_min_hours, &perm_min_minutes,
-			   &perm_max_hours, &perm_max_minutes) != 4)
-		    {
-			if (p)
-				*p = ',';
-			return(0);
-		    }
-		if (p)
-			*(p++) = ',';
-		perm_min = 60 * perm_min_hours + perm_min_minutes;
-		perm_max = 60 * perm_max_hours + perm_max_minutes;
-           	/*
-           	** The following check allows intervals over midnight ...
-           	*/
-		if ((perm_min < perm_max)
-		    ? (perm_min <= now && now <= perm_max)
-		    : (perm_min <= now || now <= perm_max))
-		    {
-			(void)sprintf(reply,
-				":%%s %%d %%s :%s %d:%02d to %d:%02d.",
-				"You are not allowed to connect from",
-				perm_min_hours, perm_min_minutes,
-				perm_max_hours, perm_max_minutes);
-			return(ERR_YOUREBANNEDCREEP);
-		    }
-		if ((perm_min < perm_max)
-		    ? (perm_min <= now + 5 && now + 5 <= perm_max)
-		    : (perm_min <= now + 5 || now + 5 <= perm_max))
-		    {
-			(void)sprintf(reply, ":%%s %%d %%s :%d minute%s%s",
-				perm_min-now,(perm_min-now)>1?"s ":" ",
-				"and you will be denied for further access");
-			return(ERR_YOUWILLBEBANNED);
-		    }
-		interval = p;
-	    }
-	return(0);
 }
 
 /*
diff -Nur irc2.10.3p7/ircd/s_conf_ext.h irc2.10.3p7+hemp2+DK+B5/ircd/s_conf_ext.h
--- irc2.10.3p7/ircd/s_conf_ext.h	Fri Feb  9 12:35:34 2001
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_conf_ext.h	Tue May 11 15:25:04 2004
@@ -58,7 +58,7 @@
 EXTERN int rehash __P((aClient *cptr, aClient *sptr, int sig));
 EXTERN int openconf();
 EXTERN int initconf __P((int opt));
-EXTERN int find_kill __P((aClient *cptr, int doall, char **comment));
+EXTERN int find_kill __P((aClient *cptr, char **comment));
 EXTERN int find_two_masks __P((char *name, char *host, int stat));
 EXTERN int find_conf_flags __P((char *name, char *key, int stat));
 EXTERN int find_restrict __P((aClient *cptr));
diff -Nur irc2.10.3p7/ircd/s_debug.c irc2.10.3p7+hemp2+DK+B5/ircd/s_debug.c
--- irc2.10.3p7/ircd/s_debug.c	Fri Oct 19 20:44:27 2001
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_debug.c	Tue May 11 15:25:04 2004
@@ -36,6 +36,9 @@
 #ifndef	NO_IDENT
 'a',
 #endif
+#ifdef MIN_CHANOP_SERV
+'B',
+#endif
 #ifdef	CHROOTDIR
 'c',
 #endif
@@ -88,6 +91,9 @@
 'K',
 # endif
 #endif
+#ifdef FAILED_OPERLOG
+'l',
+#endif
 #ifdef	LEAST_IDLE
 'L',
 #endif
@@ -123,6 +129,9 @@
 #endif
 #ifdef	OPER_REMOTE
 't',
+#ifdef TOPICWHOTIME
+'T',
+#endif
 #endif
 #ifndef	NO_PREFIX
 'u',
@@ -150,6 +159,113 @@
 #endif
 '\0'};
 
+/*
+ * Option string.  Must be before #ifdef DEBUGMODE.
+ * spaces are not allowed.
+ */
+char	cropts[] = {
+#ifdef EXTRA_STATISTICS
+'E',
+#endif
+#ifdef FAILED_OPERLOG
+'F',
+#endif
+#ifdef LOG_IP
+'I',
+#endif
+#ifdef OPER_KLINE
+'K',
+#endif
+#ifdef LOCOP_KLINE
+'k',
+#endif
+#ifdef OPER_TKLINE
+'T',
+#endif
+#ifdef LOCOP_TKLINE
+'t',
+#endif
+#ifdef RESTRICT_USERNAMES
+'u',
+#endif
+'\0'};
+
+char   flopts[] = {
+#ifdef CLIENTS_CHANNEL
+'C',
+#endif
+'\0'};
+
+char	scopts[] = {
+#ifdef EXTRA_STATISTICS
+'C',
+#endif
+#ifdef FAILED_OPERLOG
+'f',
+#endif
+#ifdef OPER_KLINE
+# ifdef LOCOP_KLINE
+'K',
+# else
+'k',
+# endif
+#endif
+#ifdef LOCAL_REJECTIONS_ONLY
+'r',
+#endif
+#ifdef TOPICWHOTIME
+'t',
+#endif
+'\0' };
+
+char jvopts[] = {
+#ifdef NO_EXTENSIVE_LOCAL_LIMIT_CHECK
+'L',
+#endif
+#ifdef STATS_F
+'F',
+#endif
+#ifdef WHOIS_SIGNON_TIME
+'s',
+#endif
+#ifdef NO_OPER_TRYAGAIN
+'N',
+#endif
+#ifdef DELAY_ACCEPT
+'d',
+#endif
+#ifdef DELAY_CLOSE
+'D',
+#endif
+#ifdef SEND_ISUPPORT
+'5',
+#endif
+#ifdef STATS_QMARK
+'?',
+#endif
+#ifdef SERVER_MAP
+'M',
+#endif
+#ifdef LIST_ALIS_NOTE
+'A',
+#endif
+#ifdef SPLIT_HANDLE
+'S',
+#endif
+#ifdef OPER_SET
+'o',
+#endif
+#ifdef ILINE_FLAGS
+'I',
+#endif
+#ifdef IAUTH_VERBOSE_REJECTS
+'v',
+#endif
+#ifdef LOG_IRCNAME
+'i',
+#endif
+'\0'
+};
 #ifdef DEBUGMODE
 static	char	debugbuf[2*READBUF_SIZE]; /* needs to be big.. */
 
@@ -358,6 +474,26 @@
 		   -1, -1
 #endif
 		   );
+	sendto_one(cptr, ":%s %d %s :Sc:%s", ME, RPL_STATSDEFINE, nick,
+					scopts);
+#ifdef  EXTRA_STATISTICS
+	sendto_one(cptr, ":%s %d %s :Cr:%s %d/%d/%d/%d/%d/%d Fl:%s",
+		   ME, RPL_STATSDEFINE, nick, cropts,
+		   istat.is_m_users, istat.is_m_myclnt,
+		   istat.is_m_service, istat.is_m_myservice,
+		   istat.is_m_serv, istat.is_m_myserv,flopts);
+#else
+	sendto_one(cptr, ":%s %d %s :Cr:%s Fl:%s",
+		   ME, RPL_STATSDEFINE, nick, cropts,flopts);
+#endif
+	sendto_one(cptr, ":%s %d %s :jv:%s Split Servers: %d (%d) Users: %d",
+		   ME, RPL_STATSDEFINE,nick,jvopts,
+#ifdef SPLIT_HANDLE
+	SPLIT_SERV,istat.is_eobservers,SPLIT_USERS
+#else
+	-1,-1,-1
+#endif
+		);
 }
 
 void	count_memory(cptr, nick, debug)
diff -Nur irc2.10.3p7/ircd/s_err.c irc2.10.3p7+hemp2+DK+B5/ircd/s_err.c
--- irc2.10.3p7/ircd/s_err.c	Sat Oct 11 00:30:37 2003
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_err.c	Tue May 11 15:25:04 2004
@@ -41,7 +41,31 @@
 /* 002 */	{ RPL_YOURHOST, ":Your host is %s, running version %s" },
 /* 003 */	{ RPL_CREATED, ":This server was created %s" },
 /* 004 */	{ RPL_MYINFO, "%s %s aoOirw abeiIklmnoOpqrstv" },
+#ifdef SEND_ISUPPORT
+/* 005 */	//{ RPL_ISUPPORT, "MAP PREFIX=(ov)@+ MODES=3 CHANTYPES=#&!+ MAXCHANNELS=%d NICKLEN=%d TOPICLEN=%d KICKLEN=%d NETWORK=%s CHANMODES=beI,k,l,imnpstaqr :are supported by this server" },
+/* 005 */	{ RPL_ISUPPORT, "%s :are supported by this server" },
+#else
 /* 005 */	{ RPL_BOUNCE, ":Try server %s, port %d" },
+#endif
+/* 006 */	{ 0, (char *)NULL },
+/* 007 */	{ 0, (char *)NULL },
+/* 008 */	{ 0, (char *)NULL },
+/* 009 */	{ 0, (char *)NULL },
+#ifdef SEND_ISUPPORT
+/* 010 */	{ RPL_BOUNCE, "%s %d :Please use this Server/Port instead" },
+#else
+/* 010 */	{ 0, (char *)NULL },
+#endif
+/* 011 */	{ 0, (char *)NULL },
+/* 012 */	{ 0, (char *)NULL },
+/* 013 */	{ 0, (char *)NULL },
+#ifdef SERVER_MAP
+/* 014 */       { 0, (char *)NULL },
+/* 015 */	{ RPL_MAP, ":%s" },
+/* 016 */   	{ 0, (char *)NULL },
+/* 017 */   	{ RPL_MAPEND, ":End of /MAP" },
+/* 018 */   	{ RPL_MAPSTART, ":%-53s | %s" },
+#endif
 		{ 0, (char *)NULL }
 };
 
@@ -62,7 +86,7 @@
 /* 413 */	{ ERR_NOTOPLEVEL, "%s :No toplevel domain specified" },
 /* 414 */	{ ERR_WILDTOPLEVEL, "%s :Wildcard in toplevel Domain" },
 /* 415 */	{ ERR_BADMASK, "%s :Bad Server/host mask" },
-/* 416 */	{ ERR_TOOMANYMATCHES, "%s :Output too long (try locally)" },
+/* 416 */	{ ERR_TOOMANYMATCHES, "%s :Output too long." },
 		{ 0, (char *)NULL },
 		{ 0, (char *)NULL },
 		{ 0, (char *)NULL },
@@ -158,7 +182,11 @@
 		{ 0, (char *)NULL },
 		{ 0, (char *)NULL },
 		{ 0, (char *)NULL },
+#ifdef NOSTATSK
+/* 499 */	{ ERR_STATSKLINE, ":" NOSTATSK },
+#else
 		{ 0, (char *)NULL },
+#endif
                 { 0, (char *)NULL },
 /* 501 */	{ ERR_UMODEUNKNOWNFLAG, ":Unknown MODE flag" },
 /* 502 */	{ ERR_USERSDONTMATCH, ":Can't change mode for other users" },
@@ -183,7 +211,11 @@
 /* 314 */	{ RPL_WHOWASUSER, "%s %s %s * :%s" },
 /* 315 */	{ RPL_ENDOFWHO, "%s :End of WHO list." },
 /* 316 */	{ RPL_WHOISCHANOP, (char *)NULL },
+#ifdef WHOIS_SIGNON_TIME
+/* 317 */	{ RPL_WHOISIDLE, "%s %ld %ld :seconds idle, signon time" },
+#else
 /* 317 */	{ RPL_WHOISIDLE, "%s %ld :seconds idle" },
+#endif
 /* 318 */	{ RPL_ENDOFWHOIS, "%s :End of WHOIS list." },
 /* 319 */	{ RPL_WHOISCHANNELS, "%s :%s" },
 		{ 0, (char *)NULL },
@@ -199,7 +231,11 @@
 		{ 0, (char *)NULL },
 /* 331 */	{ RPL_NOTOPIC, "%s :No topic is set." },
 /* 332 */	{ RPL_TOPIC, "%s :%s" },
+#ifdef TOPICWHOTIME
+/* 333 */	{ RPL_TOPICWHOTIME, "%s %s %lu" },
+#else
 		{ 0, (char *)NULL },
+#endif
 		{ 0, (char *)NULL },
 		{ 0, (char *)NULL },
 		{ 0, (char *)NULL },
@@ -247,7 +283,8 @@
 		{ 0, (char *)NULL },
 		{ 0, (char *)NULL },
 		{ 0, (char *)NULL },
-/* 381 */	{ RPL_YOUREOPER, ":You are now an IRC Operator" },
+/* 381 */	{ RPL_YOUREOPER, ":You are now known as an IRC supermouse\
+ ~(,,^>." },
 /* 382 */	{ RPL_REHASHING, "%s :Rehashing" },
 /* 383 */	{ RPL_YOURESERVICE, ":You are service %s" },
 /* 384 */	{ RPL_MYPORTIS, "%d :Port to local server is\r\n" },
@@ -293,7 +330,7 @@
 /* 217 */	{ RPL_STATSQLINE, "%c %s %s %s %d %d" },
 /* 218 */	{ RPL_STATSYLINE, "%c %d %d %d %d %ld %d.%d %d.%d" },
 /* 219 */	{ RPL_ENDOFSTATS, "%c :End of STATS report" },
-		{ 0, (char *)NULL },
+/* 220 */	{ RPL_STATSPLINE, "%c %d %s %d :%s %s" },
 /* 221 */	{ RPL_UMODEIS, "%s" },
 		{ 0, (char *)NULL },
 		{ 0, (char *)NULL },
@@ -338,7 +375,13 @@
 /* 261 */	{ RPL_TRACELOG, "File %s %d" },
 /* 262 */	{ RPL_TRACEEND, "%s %s.%s :End of TRACE" },
 /* 263 */	{ RPL_TRYAGAIN, "%s :Please wait a while and try again." },
+#ifdef EXTRA_STATISTICS
+		{ 0, (char *)NULL },
+/* 265 */	{ RPL_LOCALUSERS, ":Current local users: %d  Max: %d" },
+/* 266 */	{ RPL_GLOBALUSERS, ":Current global users: %d  Max: %d" }
+#else
 		{ 0, (char *)NULL }
+#endif
 };
 
 char	*err_str(numeric, to)
